#include <8051.h>

#define N_KEYS 6
#define ERROR_FAIL 0xC1
#define C_SUCCESS 0xC2

typedef unsigned char UINT8;
typedef unsigned int UINT16;

const UINT8 (*const code pf[])(void) = {hdr1, hdr2, hdr3, hdr4, hdr5, hdr6};

UINT8 keypress(UINT8 keyCode){
 
  if(keyCode >= N_KEYS) {
    return ERROR_FAIL;
  }
  
  return(*pf[keyCode])();
  
}
  
void main()
{
	UINT8 input= P1;
	while (1) {
	  keypress(input);
	}
}


unsigned char hdr1(void){
_asm
	MOV A, #0x01
_endasm;
	return C_SUCCESS;
}				  

unsigned char hdr2(void){
_asm
	MOV A, #0x02
_endasm;
	return C_SUCCESS;
}

unsigned char hdr3(void){
_asm
	MOV A, #0x03
_endasm;
	return C_SUCCESS;
}

unsigned char hdr4(void){
_asm
	MOV A, #0x04
_endasm;
	return C_SUCCESS;
}

unsigned char hdr5(void){
_asm
	MOV A, #0x05
_endasm;
	return C_SUCCESS;
}

unsigned char hdr6(void){
_asm
	MOV A, #0x06
_endasm;
	return C_SUCCESS;
}